Pages/PostList/Create.cshtml.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Identity;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using WebForum.Model;

using System.Security.Claims;
using Microsoft.AspNetCore.Http.Connections;
using System.Collections.Immutable;
using Microsoft.EntityFrameworkCore;

namespace WebForum.Pages.PostList
{
    public class CreateModel : PageModel
    {
        private readonly ApplicationDbContext _db;
        public string Msg;
        public CreateModel(ApplicationDbContext db)
        {
            _db = db;
        }

        [BindProperty]
        public Post Post { get; set; }

       


        public async Task<IActionResult> OnPost()
        {
            var userId = HttpContext.Session.GetString("Id");  //vrati mi loggirani Id testirano
            var userName = HttpContext.Session.GetString("Userame");
        
            if (ModelState.IsValid) 
            {
                Post.User = await _db.Users.FindAsync(userId);
                if (Post.User == null)
                {
                    Msg = "Neprijavljeni korisnik moze samo komentirati";
                    return Page();
                }
                else
                {
                    Post.Id = Guid.NewGuid().ToString();
                    await _db.Posts.AddAsync(Post);
                    await _db.SaveChangesAsync();
                    return RedirectToPage("Index");
                }
            }
                //Post.User = await _db.Users.FindAsync("2cf34c84-c92b-4ca1-a80b-d1df606c6a0f");  //ovo hardcode-iranje mi uspije spojit kljuc
                
            else
            {
                return Page();
            }
         }
    }
}

Pages/PostList/Edit.cshtml.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using WebForum.Model;

namespace WebForum.Pages.PostList
{
    public class EditModel : PageModel
    {
        private ApplicationDbContext _db;

        public EditModel(ApplicationDbContext db)
        {
            _db = db;
        }

        [BindProperty]
        public Post Post { get; set; }

        public async Task OnGet(string id)
        {
            //id = Guid.NewGuid().ToString();
            Post = await _db.Posts.FindAsync(id);
        }

        public async Task<IActionResult> OnPost()
        {
            if (ModelState.IsValid)
            {
                //Post.Id = Guid.NewGuid().ToString();
                var PostFromDb = await _db.Posts.FindAsync(Post.Id);
                if (PostFromDb == null)
                {
                    return NotFound();
                }
                //var PostFromDb = await _db.Posts.fi
                //PostFromDb.t
                PostFromDb.Title = Post.Title;
                PostFromDb.Text= Post.Text;
                
                await _db.SaveChangesAsync();
                return RedirectToPage("Index");
            }
            return RedirectToPage();
        }
    }
}

Pages/PostList/Home.cshtml.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.AspNetCore.Http;
using WebForum.Model;

namespace WebForum.Pages.PostList
{
    public class HomeModel : PageModel
    {
        private ApplicationDbContext _db;

        public HomeModel(ApplicationDbContext db)
        {
            _db = db;
        }

        [BindProperty]
        public Post Post { get; set; }
        public Comment Comment { get; set; }
        //public User User { get; set; }

        public async Task OnGet(string id)
        {
            Post = await _db.Posts.FindAsync(id);
        }
    }
}

Pages/PostList/Index.cshtml.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.EntityFrameworkCore;
using WebForum.Model;

namespace WebForum.Pages.PostList
{
    public class IndexModel : PageModel
    {
        private readonly ApplicationDbContext _db;

        public IndexModel(ApplicationDbContext db)
        {
            _db = db;
        }

        public IEnumerable<Post> Posts { get; set; }
        public IEnumerable<Comment> Comments { get; set; }

        //public IEnumerable<User> User { get; set; }

        public async Task OnGet()  //u razeru sve ovako nesto naziva HENDLER umisto metoda
        {
            Posts = await _db.Posts.Include(x => x.User).ToListAsync(); //async onmoguca vise radnji odjednom dok await-a
            //Comments = await _db.Comments.ToListAsync();
        }

        public IActionResult OnGetLogout()  
        {
            HttpContext.Session.Remove("username"); //provjeri jel username ili UserName?    -> username je tocno!
            HttpContext.Session.Remove("Id");
            return RedirectToPage("login");
        }

        public async Task<IActionResult> OnPostDelete (string id)
        {
            var post = await _db.Posts.FindAsync(id);
            var com = _db.Comments.Where(x => x.Post.Id == id).ToList();
            if (post == null)
            {
                return NotFound();  
            }
            _db.Posts.Remove(post);
            foreach (var i in com)
            {
                _db.Comments.Remove(i);
            }
            await _db.SaveChangesAsync();
            return RedirectToPage("Index");
        }
    }
}

Pages/PostList/Login.cshtml.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Security.Claims;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Identity;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using WebForum.Model;
using WebForum.Pages;

namespace WebForum.Pages.PostList
{
    public class LoginModel : PageModel
    {
        [BindProperty]
        public User user { get; set; }

        public string Msg;

        private ApplicationDbContext db;

        public LoginModel (ApplicationDbContext _db)
        {
            db = _db;
        }
    

        public void OnGet()
        {
            user = new User();
        }

        public IActionResult OnPost() //
        {
            // var userId = HttpContext.User.FindFirst(ClaimTypes.NameIdentifier)?.Value;
            var userId = db.Users.Where(x => x.UserName == user.UserName).SingleOrDefault();
            var usr = very(user.UserName, user.Password);
            if(usr == null)
            {
                HttpContext.Session.SetString("Anonymouse", usr.UserName);
                Msg = "User does not exist!";
                return Page();
            }
            else
            {
                HttpContext.Session.SetString("username", usr.UserName);
                HttpContext.Session.SetString("Id", usr.Id);
                HttpContext.Session.SetString("Role", usr.Role);
                return RedirectToPage("index");  //ovo bi ttriba bit moj INDEX
            }
        }

        private User very(string username, string password)
        {
            var user = db.Users.SingleOrDefault(a => a.UserName.Equals(username));
            if (user != null)
            {
                if(BCrypt.Net.BCrypt.Verify(password, user.Password))
                {
                    return user;
                }
            }
            return null;
        }
    }
}

Pages/PostList/Show.cshtml.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using WebForum.Model;
using Microsoft.AspNetCore.Http;
using Microsoft.EntityFrameworkCore;
namespace WebForum.Pages.PostList
{
    public class ShowModel : PageModel
    {
        private readonly ApplicationDbContext _db;

        public ShowModel(ApplicationDbContext db)
        {
            _db = db;
        }

        [BindProperty]
        public Post Post { get; set; }

        [BindProperty]    //Bez bindanja mi ne radi Guid
        public Comment Comment { get; set; }

        public IEnumerable<Post> Posts { get; set; }
        public IEnumerable<Comment> Comments { get; set; }

       
        public async Task OnGet(string id)
        {
            // Comments = await _db.Comments.ToListAsync();
            Comments =  _db.Comments.Include(x => x.User).Where(x => x.Post.Id == id).ToList();

            Comment = await _db.Comments.FindAsync(id);
            Post = await _db.Posts.FindAsync(id);
        }

        //public async Task OnGet(string id)
        //{
        //    Post = await _db.Posts.FindAsync(id);
           
        //}

        public async Task<IActionResult> OnPost()
        {
            var userId = HttpContext.Session.GetString("Id");
            if (!ModelState.IsValid)
            {
                var postId = _db.Posts.Where(x => x.Id == Post.Id).SingleOrDefault();
                Comment.User = await _db.Users.FindAsync(userId);
                //Comment.Post = await _db.Posts.FindAsync("3c1e7ea6-fe70-4a62-91c9-089a9b38411d"); //valja!
                Comment.Post = await _db.Posts.FindAsync(postId.Id);
                Comment.Id = Guid.NewGuid().ToString();
                await _db.Comments.AddAsync(Comment);
                await _db.SaveChangesAsync();
                return RedirectToPage("Index");
            }
            else
            {
                return Page();
            }
        }
    }
}

Pages/PostList/SignUp.cshtml.cs
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using WebForum.Model;
using System;
using Microsoft.CodeAnalysis.CSharp.Syntax;

namespace WebForum.Pages.PostList
{
    public class SignUpModel : PageModel
    {
        [BindProperty]
        public User user { get; set; }

        private ApplicationDbContext db;

        public SignUpModel(ApplicationDbContext _db)
        {
            db = _db;
        }
        public void OnGet()
        {
            user = new User();
        }

        public IActionResult OnPost() //mora sam dodat ekstenziju za ovaj BCrypt / IactionResul PROVJERI
        {
            user.Id = Guid.NewGuid().ToString();
            user.Role = "User";
            user.Password = BCrypt.Net.BCrypt.HashPassword(user.Password);
            db.Users.Add(user);
            db.SaveChanges();
            return RedirectToPage("login");
        }
    }
}

Pages/PostList/Create.cshtml
@page
@model WebForum.Pages.PostList.CreateModel


<br />
<h2 class="text-info">Create New Post</h2>
<br />

<div class="border container" style="padding:30px;">
    
    <form method="post">
        <div class="text-danger" asp-validation-summary="ModelOnly"></div>
        <div class="form-group row">
            <div class="col-3">
                <label asp-for="Post.Title"></label>
            </div>
            <div class="col-6">
                <input asp-for="Post.Title" class="form-control" />
            </div>
            <span asp-validation-for="Post.Title" class="text-danger"></span>
        </div>
        <div class="form-group row">
            <div class="col-3">
                <label asp-for="Post.Text"></label>
            </div>
            <div class="col-6">
                <textarea asp-for="Post.Text" class="form-control" id="txtarea" rows="4"></textarea>
            </div>
        </div>
        <div class="form-group row">
            <div class="col-3 offset-3">
                <a asp-page="Index" class="btn btn-success form-control">Back to List</a>
            </div>
            <div class="col-3">
                <input type="submit" value="Create" class="btn btn-primary form-control" />
            </div>
        </div>
    </form>
</div>


@section Scripts{
    <partial name="_ValidationScriptsPartial" />   <!-- da mi ostane pokazivac na npr Title ako je prazan a requide je -->
}

Pages/PostList/Edit.cshtml
@page
@model WebForum.Pages.PostList.EditModel


<br />
<h2 class="text-info">Edit Post</h2>
<br />

<div class="border container" style="padding:30px;">
    <form method="post">
        <input type="hidden" asp-for="Post.Id" />
        <div class="text-danger" asp-validation-summary="ModelOnly"></div>
        <div class="form-group row">
            <div class="col-3">
                <label asp-for="Post.Title"></label>
            </div>
            <div class="col-6">
                <input asp-for="Post.Title" class="form-control" />
            </div>
            <span asp-validation-for="Post.Title" class="text-danger"></span>
        </div>
        <div class="form-group row">
            <div class="col-3">
                <label asp-for="Post.Text"></label>
            </div>
            <div class="col-6">
                <textarea asp-for="Post.Text"  class="form-control" id="txtarea" rows="4"></textarea>
            </div>

        </div>
        <div class="form-group row">
            <div class="col-3">
            </div>
            <div class="col-6">
            </div>
        </div>
        <div class="form-group row">
            <div class="col-3 offset-3">
                <a asp-page="Index" class="btn btn-success form-control">Back to List</a>
            </div>
            <div class="col-3">
                <input type="submit" value="Save Change" class="btn btn-primary form-control" />
            </div>
        </div>
    </form>
</div>


@section Scripts{
    <partial name="_ValidationScriptsPartial" />   <!-- da mi ostane pokazivac na npr Title ako je prazan a requide je -->
}

Pages/PostList/Home.cshtml
@page
@model WebForum.Pages.PostList.HomeModel

@using Microsoft.AspNetCore.Http


<!DOCTYPE html>
<html lang="en">

<head>
    <title> Welcome </title>

</head>
<body>

    Welcome @HttpContext.Session.GetString("username")
   

    
    <br>
    <a asp-page="index" asp-page-handler="logout"> Logout </a>
    <a asp-page="home"> Change profile </a>



</body>
</html>

Pages/PostList/Index.cshtml
@page
@model WebForum.Pages.PostList.IndexModel
@using Microsoft.AspNetCore.Http
@using Microsoft.AspNetCore.Session

<style>
.button {background-color: #f44336;}
</style>


<div class="container row p-0 m-0">
    <div class="col-9">
        <h2 class="text-info"> Post List </h2>
    </div>
    <div class="form-group row">

        @if (HttpContext.Session.GetString("username") != null)
        {
            <p> Logged as: <strong> @HttpContext.Session.GetString("username")   </strong></p>
            <a asp-page="index" asp-page-handler="logout">  &nbsp; &nbsp;&nbsp; <button class="button" type="button" color="red"> LOGOUT </button> </a>
        }
        else
        {
            <p> Logged as: <strong> Anonymous </strong> </p>
        }
    </div>
    <div class="col-3">
        @if (HttpContext.Session.GetString("username") != null)
        {
            <a asp-page="Create" class="btn btn-info form-control text-white"> New Post </a>
        }
        else
        {
            <p> The unregistered user can only comment </p>
        }
    </div>

    @if (HttpContext.Session.GetString("username") != null && string.Compare(HttpContext.Session.GetString("Role"), "Admin", true) == 0)
    {
        <div class="col-12 border p-3 mt-3">

            <form method="post">

                @if (Model.Posts == null)
                {
                    <p>No posts available.</p>
                }
                else if (Model.Posts.Count() > 0)
                {
                    <table class="table table-striped border">
                        <tr class="table-secondary">
                            <th>
                                <label asp-for="Posts.FirstOrDefault().Title"> </label>
                            </th>
                            <th>
                                <label asp-for="Posts.FirstOrDefault().User.UserName"> Author </label>
                            </th>
                            <th>
                                <label asp-for="Posts.FirstOrDefault().PostDataTime"> Date </label>
                            </th>
                            <th>

                            </th>
                        </tr>
                        @foreach (var item in Model.Posts)
                        {
                            <tr>
                                <td>
                                    @Html.DisplayFor(m => item.Title)
                                </td>
                                <td>
                                    @Html.DisplayFor(m => item.User.UserName)
                                </td>
                                <td>
                                    @Html.DisplayFor(m => item.PostDataTime)
                                </td>
                                    <td>
                                        <a asp-page="Show" asp-route-id="@item.Id" class="btn btn-success btn-sm text-white">Show</a>
                                        <a asp-page="Edit" asp-route-id="@item.Id" class="btn btn-warning btn-sm text-white">Edit</a>
                                        <button asp-page-handler="Delete" asp-route-id="@item.Id" onclick="return confirm('Are you sure you want to delete?')" class="btn btn-danger btn-sm">Delete</button>
                                    </td>
                            </tr>
                        }
                    </table>
                }
            </form>
        </div>
    }


   else if (HttpContext.Session.GetString("username") != null && string.Compare(HttpContext.Session.GetString("Role"), "User", true) == 0)
    {
        <div class="col-12 border p-3 mt-3">

            <form method="post">

                @if (Model.Posts == null)
                {
                    <p>No posts available.</p>
                }
                else if (Model.Posts.Count() > 0)
                {
                    <table class="table table-striped border">
                        <tr class="table-secondary">
                            <th>
                                <label asp-for="Posts.FirstOrDefault().Title"> </label>
                            </th>
                            <th>
                                <label asp-for="Posts.FirstOrDefault().User.UserName"> Author </label>
                            </th>
                            <th>
                                <label asp-for="Posts.FirstOrDefault().PostDataTime"> Date </label>
                            </th>
                            <th>

                            </th>
                        </tr>
                        @foreach (var item in Model.Posts)
                        {
                            <tr>
                                <td>
                                    @Html.DisplayFor(m => item.Title)
                                </td>
                                <td>
                                    @Html.DisplayFor(m => item.User.UserName)
                                </td>
                                <td>
                                    @Html.DisplayFor(m => item.PostDataTime)
                                </td>
                                @if (string.Compare(item.User.UserName.ToString().ToUpper(), HttpContext.Session.GetString("username").ToUpper(), true) == 0)


                                {
                                    <td>
                                        <a asp-page="Show" asp-route-id="@item.Id" class="btn btn-success btn-sm text-white">Show</a>
                                        <a asp-page="Edit" asp-route-id="@item.Id" class="btn btn-warning btn-sm text-white">Edit</a>
                                        <button asp-page-handler="Delete" asp-route-id="@item.Id" onclick="return confirm('Are you sure you want to delete?')" class="btn btn-danger btn-sm">Delete</button>
                                    </td>
                                }
                                else
                                {
                                    <td>
                                        <a asp-page="Show" asp-route-id="@item.Id" class="btn btn-success btn-sm text-white">Show</a>
                                    </td>
                                }

                            </tr>
                        }
                    </table>
                }
            </form>
        </div>
    }


    else
    {
        <div class="col-12 border p-3 mt-3">
            <form method="post">

                @if (Model.Posts == null)
                {
                    <p>No posts available.</p>
                }
                else if (Model.Posts.Count() > 0)
                {
                    <table class="table table-striped border">
                        <tr class="table-secondary">
                            <th>
                                <label asp-for="Posts.FirstOrDefault().Title"> </label>
                            </th>
                            <th>
                                <label asp-for="Posts.FirstOrDefault().User.UserName"> Author </label>
                            </th>
                            <th>
                                <label asp-for="Posts.FirstOrDefault().PostDataTime"> Date </label>
                            </th>
                            <th>

                            </th>
                        </tr>
                        @foreach (var item in Model.Posts)
                        {
                            <tr>
                                <td>
                                    @Html.DisplayFor(m => item.Title)
                                </td>
                                <td>
                                    @Html.DisplayFor(m => item.User.UserName)
                                </td>
                                <td>
                                    @Html.DisplayFor(m => item.PostDataTime)
                                </td>
                                <td>
                                    <a asp-page="Show" asp-route-id="@item.Id" class="btn btn-success btn-sm text-white">Show Post</a>
                                </td>
                            </tr>
                        }
                    </table>
                }
            </form>
        </div>
    }
</div>

Pages/PostList/Login.cshtml
@page
@model WebForum.Pages.PostList.LoginModel



<div class="container row p-0 m-0">
    <div class="col-9">
        <h2 class="text-info">Log In</h2>
    </div>


    <div class="col-9 border p-3 mt-3">
        <form method="post" asp-page="very">
            @Model.Msg
            <table class="table table-striped border">
                <tr class="table-secondary">
                    <td> Username </td>
                    <td>
                        <input asp-for="@Model.user.UserName " />
                    </td>
                <tr class="table-secondary">
                    <td> Password </td>
                    <td>
                        <input type="password" asp-for="@Model.user.Password " />
                    </td>
                </tr>
                <tr class="table-secondary">
                    <td>                      
                        <a asp-page="Index" class="btn btn-success form-control col-4">Back</a>
                    </td>
                    <td>
                        <input type="submit" value="Log In" class="btn btn-primary btn-sm text-white col-3" />
                    </td>                  
                </tr>
            </table>
        </form>
    </div>
</div>

Pages/PostList/Show.cshtml
@page
@model WebForum.Pages.PostList.ShowModel



<h2 class="text-info">Show Post</h2>
<br/>

<div class="border container" style="padding:30px;">

    <input type="hidden" asp-for="Post.Id" />
    <div class="form-group ">
        <p><h1> <strong> @Model.Post.Title  </strong></h1></p>
    </div>
    <div class="form-group">
        <p>  @Model.Post.Text </p>
    </div>
    <div class="form-group">
        <p style="float: right"> <strong><i> @Model.Post.PostDataTime </i> </strong></p>
    </div>
    <br>
    <input type="hidden" asp-for="Comment.Id" />

    @if (Model.Comments == null)
    {
        <p>No comments available.</p>
    }
    else if (Model.Comments.Count() > 0)
    {
        <table class="table table-striped border">
            <tr class="table-secondary">
                <th>
                    <label asp-for="Comments.FirstOrDefault().Text"> <strong> Comments:</strong> </label>
                </th>
            </tr>
            @foreach (var item in Model.Comments.OrderBy(x => x.CommentDate))
            {
                <tr>
                    <td>
                        @if (@item.User != null)
                        {
                            <p><strong> @Html.DisplayFor(m => item.User.UserName):</strong>  @Html.DisplayFor(m => item.Text) </p>
                            <p><i><small>   @Html.DisplayFor(m => item.CommentDate) </small></i></p>
                        }
                        else if(@item.User == null)
                        {
                            <p><strong> Anonymouse: </strong>  @Html.DisplayFor(m => item.Text) </p>
                            <p><i><small>  @Html.DisplayFor(m => item.CommentDate) </small></i></p>
                        }
                    </td>
                </tr>
            }
        </table>
    }
</div>
    <br>
    <form method="post">
        <div class="form-group row">
            <div class="col-7">
                <label asp-for="Comment.Id"> <strong> Comment: </strong></label>
            </div>
            <div class="col-6">
                <textarea asp-for="Comment.Text" class="form-control" id="txtarea" rows="2"></textarea>
            </div>
        </div>

        <div class="form-group row">
            <div class="col-1">
                <a asp-page="Index" class="btn btn-success form-control">Back</a>
            </div>
            <div class="col-2 offset-3">
                <input type="submit" value="Done" class="btn btn-primary form-control" />
            </div>
        </div>
    </form>

Pages/PostList/SignUp.cshtml
@page
@model WebForum.Pages.PostList.SignUpModel


<div class="container row p-0 m-0">
    <div class="col-9">
        <h2 class="text-info">Sign Up</h2>
    </div>


    <div class="col-9 border p-3 mt-3">
        <form method="post" asp-page="signup">
            <table class="table table-striped border">
                <tr class="table-secondary">
                    <td> Username </td>
                    <td>
                        <input asp-for="@Model.user.UserName " />
                    </td>
                </tr>
                <tr class="table-secondary">
                    <td> Email </td>
                    <td>
                        <input type="email" asp-for="@Model.user.Email " />
                    </td>
                </tr>
                <tr class="table-secondary">
                    <td> Password </td>
                    <td>
                        <input type="password" asp-for="@Model.user.Password " />
                    </td>
                </tr>
                <tr class="table-secondary">
                    <td>                      
                        <a asp-page="Index" class="btn btn-success form-control col-4">Back</a>
                    </td>
                    <td>
                        <input type="submit" value="Save" class="btn btn-primary btn-sm text-white col-3" />
                    </td>   
                </tr>
            </table>
        </form>
    </div>
</div>